{%- from "kibana/map.jinja" import client with context %}
{%- if client.get('enabled', False) %}

  {%- set kibana_version = salt['pkg.version']('kibana') %}

  {%- if kibana_version is defined %}
kibana_object_config_{{ kibana_version }}:
  kibana_object.present:
  {%- if client.version in [4, 5] %}
  - kibana_content:
      defaultIndex: {{ client.get('default_index', {}) }}
  - name: {{ kibana_version }}
  - kibana_type: 'config'
  {%- elif client.version == 6 %}
  - kibana_content:
      config:
        defaultIndex: {{ client.get('default_index', {}) }}
      type: config
  - name: 'config:{{ kibana_version }}'
  - kibana_type: 'doc'
  {%- endif %}

  {%- for object_name, object in client.get('object', {}).iteritems() %}
    {%- if object.get('enabled', False) %}
      {%- set pillar_content = object.get("content", {}) %}
      {%- if object.template is defined %}
        {%- import_json object.template as content %}
      {%- else %}
        {%- set content = {} %}
      {%- endif %}
      {%- do salt['defaults.merge'](content, pillar_content) %}

kibana_object_{{ object.type }}_{{ object_name }}:
  kibana_object.present:
  - kibana_content: {{ content | json }}
      {%- if client.version in [4, 5] %}
  - name: {{ object.id | default(object_name) }}
  - kibana_type: {{ object.type }}
      {%- elif client.version == 6 %}
  - name: {{ object.type }}:{{ object.id | default(object_name) }}
  - kibana_type: "doc"
      {%- endif %}
    {%- else %}

kibana_object_{{ object_name }}:
  kibana_object.absent:
  - name: {{ object.id | default(object_name) }}
  - kibana_type: {{ object.type }}

    {%- endif %}

  {%- endfor %}
  {%- endif %}
{%- endif %}
